LabeledSkinBase (JavaFX 17)

Module javafx.controls
Package javafx.scene.control.skin

## Class LabeledSkinBase<C extends Labeled>

- java.lang.Object
- - javafx.scene.control.SkinBase<C>
  - - javafx.scene.control.skin.LabeledSkinBase<C>

- All Implemented Interfaces:
    `Skin<C>`
  Direct Known Subclasses:
    `ButtonSkin`, `CellSkinBase`, `CheckBoxSkin`, `HyperlinkSkin`, `LabelSkin`, `RadioButtonSkin`, `TitledPaneSkin`, `ToggleButtonSkin`

      public abstract class LabeledSkinBase<C extends Labeled>
      extends SkinBase<C>

  Default skin implementation for controls extends `Labeled`.
  Since:
    9
  See Also:
    `Labeled`

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `LabeledSkinBase​(C labeled)` | Constructor for LabeledSkinBase.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected double` | `computeMinWidth​(double height, double topInset, double rightInset, double bottomInset, double leftInset)` | Compute and return the minimum width of this Labeled.
    `protected void` | `layoutChildren​(double x, double y, double w, double h)` | The Layout algorithm works like this: - Get the labeled w/h, graphic w/h, text w/h - Compute content w/h based on graphicVPos, graphicHPos, graphicTextGap, and graphic w/h and text w/h - (Note that the text content has been pre-truncated where necessary) - compute content x/y based on content w/h and labeled w/h and the labeled's hpos and vpos - position the graphic and text
    `protected void` | `layoutLabelInArea​(double x, double y, double w, double h)` | Performs the actual layout of the label content within the area given.
    `protected void` | `layoutLabelInArea​(double x, double y, double w, double h, Pos alignment)` | Performs the actual layout of the label content within the area given.
    `protected void` | `updateChildren()` | Updates the children managed by LabeledSkinBase, which can be the Labeled graphic and/or a Text node.

    - ### Methods declared in class javafx.scene.control.SkinBase

      `computeBaselineOffset, computeMaxHeight, computeMaxWidth, computeMinHeight, computePrefHeight, computePrefWidth, consumeMouseEvents, executeAccessibleAction, getChildren, getClassCssMetaData, getCssMetaData, layoutInArea, layoutInArea, layoutInArea, positionInArea, positionInArea, pseudoClassStateChanged, queryAccessibleAttribute, registerChangeListener, registerInvalidationListener, registerListChangeListener, snappedBottomInset, snappedLeftInset, snappedRightInset, snappedTopInset, snapPosition, snapPositionX, snapPositionY, snapSize, snapSizeX, snapSizeY, snapSpace, snapSpaceX, snapSpaceY, unregisterChangeListeners, unregisterInvalidationListeners, unregisterListChangeListeners`

    - ### Methods declared in class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods declared in interface javafx.scene.control.Skin

      `dispose, getNode, getSkinnable`

- - ### Constructor Detail

    - #### LabeledSkinBase

          public LabeledSkinBase​(C labeled)

      Constructor for LabeledSkinBase. The Labeled must be specified, and cannot be null. At the conclusion of the constructor call, the skin will be marked as needsLayout, and will be fully configured based on the current state of the labeled. Any subsequent changes to the Labeled will be handled via listeners and applied appropriately.
      Parameters:
        `labeled` - The labeled that this skin should be installed onto.

  - ### Method Detail

    - #### updateChildren

          protected void updateChildren()

      Updates the children managed by LabeledSkinBase, which can be the Labeled graphic and/or a Text node. Only those nodes which actually must be used are used. For example, with a ContentDisplay of GRAPHIC_ONLY the text node is not added, and with a ContentDisplay of TEXT_ONLY, the graphic is not added.

    - #### computeMinWidth

          protected double computeMinWidth​(double height,
                                           double topInset,
                                           double rightInset,
                                           double bottomInset,
                                           double leftInset)

      Compute and return the minimum width of this Labeled. The minimum width is the smaller of the width of "..." and the width with the actual text. In this way, if the text width itself is smaller than the ellipsis then we should use that as the min width, otherwise the ellipsis needs to be the min width.

      We use the same calculation here regardless of whether we are talking about a single or multiline labeled. So a multiline labeled may find that the width of the "..." is as small as it will ever get.

      Overrides:
        `computeMinWidth` in class `SkinBase<C extends Labeled>`
      Parameters:
        `height` - The height of the Skin, in case this value might dictate the minimum width.
        `topInset` - the pixel snapped top inset
        `rightInset` - the pixel snapped right inset
        `bottomInset` - the pixel snapped bottom inset
        `leftInset` - the pixel snapped left inset
      Returns:
        A double representing the minimum width of this Skin.

    - #### layoutChildren

          protected void layoutChildren​(double x,
                                        double y,
                                        double w,
                                        double h)

      The Layout algorithm works like this: - Get the labeled w/h, graphic w/h, text w/h - Compute content w/h based on graphicVPos, graphicHPos, graphicTextGap, and graphic w/h and text w/h - (Note that the text content has been pre-truncated where necessary) - compute content x/y based on content w/h and labeled w/h and the labeled's hpos and vpos - position the graphic and text
      Overrides:
        `layoutChildren` in class `SkinBase<C extends Labeled>`
      Parameters:
        `x` - the x position
        `y` - the y position
        `w` - the width
        `h` - the height

    - #### layoutLabelInArea

          protected void layoutLabelInArea​(double x,
                                           double y,
                                           double w,
                                           double h)

      Performs the actual layout of the label content within the area given. This method is called by subclasses that override layoutChildren().
      Parameters:
        `x` - The x position of the label part of the control, inside padding
        `y` - The y position of the label part of the control, inside padding
        `w` - The width of the label part of the control, not including padding
        `h` - The height of the label part of the control, not including padding

    - #### layoutLabelInArea

          protected void layoutLabelInArea​(double x,
                                           double y,
                                           double w,
                                           double h,
                                           Pos alignment)

      Performs the actual layout of the label content within the area given. This method is called by subclasses that override layoutChildren().
      Parameters:
        `x` - The x position of the label part of the control, inside padding
        `y` - The y position of the label part of the control, inside padding
        `w` - The width of the label part of the control, not including padding
        `h` - The height of the label part of the control, not including padding
        `alignment` - The alignment of the label part of the control within the given area. If null, then the control's alignment will be used.